unit graph_fx;
{kleine Grafik- UNIT fr mode 13h des Bios, 320x200x 256 Farben}
interface
Type
  tColorValue = Record
    Rvalue,  {Rot-Anteil}
    Gvalue,  {Grn-Anteil}
    Bvalue : {Blau-Anteil}
		         Byte;
  end;

  tPalette= Array [0..255] of tColorValue;
  pPalette= ^tPalette;

  Procedure PutPixel(x,y:Word;col:Byte);
   {Frbt pixel(x,y) mit col}
  Function getpixel(x,y:Word):byte;
   {ermittelt die Farbe des Pixels}
  Procedure Init_grafik;
   {schaltet in den Grafik-Modus}
  Procedure SetVGAPalette(tp : tPalette);
   {setzt die Farbpalette tp }
  Procedure getPalette(var Pal: tPalette);
   {sichert sie Farbpalette nach Pal}

implementation
const Grafik_Initialisiert: Boolean=false;

  procedure getPalette(var Pal: tPalette);
  var buffer : array[1..3*256] of byte ABSOLUTE pal;

      i : word;
  begin
    port[$3c7]:=0; { erste Farbe, die man holen will : Col_nr:0, RGB: rot}
    for i := 1 to 256*3 do buffer[i] := port[$3c9];  { von allen 256 Farben der Palette alle RGB-Anteile Speichern}

{    move(Buffer, Original_Palette,3*256);
     diese Zeile wurde durch die ABSOLUTE Anweisung berflssig }
  end;{getPalette}

  Procedure SetVGAPalette(tp : tPalette);
  Var
    buffer : array[1..3*256] of byte ABSOLUTE tp;
    { die beiden Variablen buffer und Tp befinden sich an identischen Speicherbereichen}
    i : word;
  begin { Procedure VGApalette }
    port[$3c8] :=0;        { Farbwert, den man ndern will, nach einer Port[$3c8] Aktion
	                           wird dieser Zhler automatisch erhht, somit steht hier immer ein Wert, i-1 ( vom 0..3*256-1) }
    for i := 1 to 256*3 do port[$3c9] := buffer[i];
                           { die Bytes aus dem Pufferarray, die den Bytes aus dem Paletten-Record entsprechen 1:1 in die
												     Grafik-Karte schreiben}
  end; { Procedure SetVGApalette }

(*
  { die Asm-Routinen sind irgendwo abgekupfert, aber die Routinen gleichen Namens sind von mir}
  Procedure SetVGAPalette(tp : tPalette);
  Var
    regs : Registers;
  begin { Procedure VGApalette }
    Regs.AX := $1012;
    Regs.BX := 0; { first register to set }
    Regs.CX := 256; { number of Registers to set }
    Regs.ES := Seg(tp);
    Regs.DX := Ofs(tp);
    Intr($10, regs);
  end;

  procedure getPalette(var pal: tPalette);
  begin
    asm
      push di
      mov di,offset pal             {Adresse holen}
      mov cx,256*3                  {Anzahl Farben holen}
      xor al,al                     {al := 0}
      mov dx,03c7h                  {External Palette RAM, Pixel Read Adress}
      out dx,al                     {ab Farbe 0 lesen            }
      mov dx,3c9h                   {Pixel Color Value           }

      rep insb                      {alle Farben an VGA schicken}
      pop di
    end;
  end;

  Procedure PutPixel(x,y:Word;col:Byte);
  Begin
    if grafik_initialisiert then Begin
      asm
        mov ax, 0a000h
        mov es, ax
        { ldt Grafik-Addr in es}
        mov ax, 320
        mul y
        add ax, x
        {bis hierhin: ax := y*320 +x}
        mov di, ax
        {di wird mit ax geladen, was die Addresse des gewnschten Pixels(word)
         ergibt (das Pixel, das mit col geladen werden soll liegt an: mem[SegA000:(y*320+x)])}
        mov al, byte ptr col
        {al wird mit dem Byte col geladen}
        mov es:[di], al
        { mem[SegA000:(320*y+x)] := col ;
		  	  mit dieser Zeile lt sich der gesamte asm-Block in TP ersetzen
				  diese Anweisung ist auch genauso schnell, der Asm-Block sieht aber
				  proffessioneller aus :) }
      end;
	  end
	  else write(#7);
  end;{putpixel}

*)

Procedure Init_grafik;
Begin
  asm
    mov ax,13h
    int 10h
  end; { schaltet in 320x200 Modus mit 256(!) Farben
	       in TP: regs.ax := $13 ;
				     Intr($10,regs) ; }
  grafik_initialisiert := true;
end;{init_grafik}

function getpixel(x,y:Word):byte;
Begin
  getpixel:=mem[SegA000:(x+y*320)];
end;{getpixel}

Procedure PutPixel(x,y:Word;col:Byte);
Begin
  if grafik_initialisiert then
	  mem[SegA000:(320*y+x)] := col
	else
	  write(#7);
end;{putpixel}

end.{unit Graph_FX}