Unit Ini_file;

Interface

Type
	tIni_IO = Object

		gefunden: Boolean;

		Akt_Datei: String;

		Procedure Schreibe_Wert(Feld_Bezeichner, Feld_Wert: String);

		Function Lese_Wert(Feld_Bezeichner: String):String;

		Procedure Schreibe_Real(Feld_Bezeichner: String; rZahl:Real; ins, Nachkomma:Byte);

		Function Lese_Real(Feld_Bezeichner: String):Real;

		Procedure Schreibe_Int(Feld_Bezeichner: String; iZahl: LongInt);

		Function Lese_Int( Feld_Bezeichner : String): LongInt;

		Procedure Schreibe_Bool(Feld_Bezeichner: String; Bool: Boolean);

		Function Lese_Bool( Feld_Bezeichner : String): Boolean;

    Procedure Schreibe_Kommentar(Feld_Bezeichner,Kommentar: String);
	end;{tIni_IO}

	Procedure Schreibe_ini_eintrag(Ini_datei,Datenfeld_bez,Datenfeld_wert:String);

	Function Lese_ini_eintrag(Ini_datei,Datenfeld_bez:String):String;


{end of Interface}

Implementation

	Uses Crt,Dos, Str_func, menusys, Konv_Uni;

Procedure Schreibe_ini_eintrag(Ini_datei,Datenfeld_bez,Datenfeld_wert:String);
Const
	Feld_gefunden:Boolean=False;
Var
	F_out,F_in:Text;
	Dirinfo:Searchrec;
	Akt_zeile:String;
Begin
	Findfirst(Ini_datei,Archive,Dirinfo);
	If Doserror=0 Then Begin
		Assign(F_out,Ini_datei);
		Reset(F_out);
		Assign(F_in,'temp_ini.tmp');
		Rewrite(F_in);

		While Not Eof(F_out) Do Begin
			Readln(F_out,Akt_zeile);
			If ( Pos( Up_String( Datenfeld_bez ), Up_String( Akt_zeile ) ) > 0 )
			And Not ( Akt_zeile[1] in ['#',';'] ) Then
			Begin
				Writeln( F_in,Datenfeld_bez + '=' + Datenfeld_wert );
				Feld_gefunden := True;
			End
			Else Writeln( F_in, Akt_zeile);
		End;
		If Not Feld_gefunden Then
			Writeln( F_in, Datenfeld_bez + '=' + Datenfeld_wert);

		Close(F_out);
		Erase(F_out);
		Close(F_in);
		Rename(F_in,Ini_datei);
	End
	Else {neue Datei erzeugen} Begin
		Assign(F_in,Ini_datei);
		Rewrite(F_in);
		Writeln( F_in, Datenfeld_bez + '=' + Datenfeld_wert);
		Close(F_in);
	End;
End; {Schreibe_ini_eintrag}

Procedure Schreibe_ini_Kommentar(Ini_datei,Datenfeld_bez,Kommentar:String);
Const
	Feld_gefunden:Boolean=False;
Var
	F_out,F_in:Text;
	Dirinfo:Searchrec;
	Akt_zeile:String;
Begin
	Findfirst(Ini_datei,Archive,Dirinfo);
	If Doserror=0 Then Begin
		Assign(F_out,Ini_datei);
		Reset(F_out);
		Assign(F_in,'temp_ini.tmp');
		Rewrite(F_in);

		While Not Eof(F_out) Do Begin
			Readln(F_out,Akt_zeile);
			If ( Pos( Up_String( Datenfeld_bez ), Up_String( Akt_zeile ) ) > 0 )
			And Not ( Akt_zeile[1] in ['#',';'] ) Then
			Begin
				Writeln( F_in,Akt_zeile);
        writeln( F_in, '#'+ Kommentar);
        { kommentar in der Zeile, die auf das Feld folgt}
				Feld_gefunden := True;
			End
			Else Writeln( F_in, Akt_zeile)
		End;
{		If Not Feld_gefunden Then
			Writeln( F_in, Datenfeld_bez + '=' + Datenfeld_wert);
  s. o.  }
		Close(F_out);
		Erase(F_out);
		Close(F_in);
		Rename(F_in,Ini_datei);
	End;
End; {Schreibe_ini_Kommentar}

Function Lese_ini_eintrag( Ini_datei, Datenfeld_bez:String):String;
Var
	F_out:Text;
	Dirinfo:Searchrec;
	Akt_zeile:String;
	gefunden: Boolean;
	p : Byte;
Begin
	Lese_ini_eintrag:='';
	gefunden:=false;

	Findfirst(Ini_datei,Archive,Dirinfo);
	If Doserror=0 Then Begin
		Assign(F_out,Ini_datei);
		Reset(F_out);

		While (Not Eof(F_out)) and (not gefunden) Do Begin
			Readln( F_out, Akt_zeile);
			p :=Pos( Up_String( Datenfeld_bez), Up_String( Akt_zeile));
			If ( p > 0 ) And Not ( Akt_zeile[1] in ['#',';'] ) Then Begin
				Delete( Akt_zeile, p, Length( Datenfeld_bez)+1);
				Lese_ini_eintrag:=Akt_zeile;
				gefunden := true;
				Break;
			End;
		End;
		Close(F_out);

		if not gefunden then Begin
			Fehlerbox('Achtung: Wert '+Datenfeld_bez+';nicht gefunden!;'+
								'Vielleicht falsche Schreibweise! CENTERED');
			Lese_Ini_Eintrag :='';
		end;

	End
	Else {ini_datei nicht gefunden} Begin
		fehlerbox('Ini-Datei: '+ini_datei+' existiert nicht');
	End;
End; {Lese_ini_eintrag}


{----- Objekt tIni_IO -------}

Procedure tIni_IO.Schreibe_Wert(Feld_Bezeichner, Feld_Wert: String);
Begin
	if Akt_Datei='' then fehlerbox(' Noch keine Akt_Datei zugewiesen!')
	else Begin
		Schreibe_ini_eintrag(Akt_Datei,Feld_Bezeichner, Feld_Wert);
	end;
end; {tIni_IO.Schreibe_Wert}

Function tIni_IO.Lese_Wert(Feld_Bezeichner: String):String;
var s : String;
Begin
	if Akt_Datei='' then fehlerbox(' Noch keine Akt_Datei zugewiesen!')
	else Begin
		s:= Lese_Ini_Eintrag(Akt_Datei,Feld_Bezeichner);
		gefunden := s <> '';
		Lese_Wert:= s;
	end;
end; {tIni_IO.Lese_Wert}

Procedure tIni_IO.Schreibe_Real(Feld_Bezeichner: String; rZahl:Real; ins, Nachkomma:Byte);
var sZahl: String;
Begin
	if Akt_Datei='' then fehlerbox(' Noch keine Akt_Datei zugewiesen!')
	else Begin
		sZahl:=RealtoStr(rZahl,ins, Nachkomma);
		Schreibe_Ini_Eintrag(Akt_Datei,Feld_Bezeichner, sZahl);
	end;
end; {Schreibe_Real}

Function tIni_IO.Lese_Real(Feld_Bezeichner: String):Real;
var s: String;
		r : Real;
Begin
	r := 0;
	if Akt_Datei='' then fehlerbox(' Noch keine Akt_Datei zugewiesen!')
	else Begin
		s := Lese_Ini_Eintrag(Akt_Datei,Feld_Bezeichner);
		gefunden := s <> '';
		if gefunden then r := Str2Real(s);
	end;
	Lese_Real := r;
end; {tIni_IO.Lese_Real}

Procedure tIni_IO.Schreibe_Int(Feld_Bezeichner: String; iZahl: LongInt);
var sZahl: String;
Begin
	if Akt_Datei='' then fehlerbox(' Noch keine Akt_Datei zugewiesen!')
	else Begin
		sZahl:=InttoStr(iZahl);
		Schreibe_Ini_Eintrag(Akt_Datei,Feld_Bezeichner, sZahl);
	end;
end; {tIni_IO.Schreibe_Int}

Function tIni_IO.Lese_Int( Feld_Bezeichner : String): LongInt;
var s : String;
Begin
	if Akt_Datei='' then fehlerbox(' Noch keine Akt_Datei zugewiesen!')
	else Begin
		s := Lese_Ini_Eintrag(Akt_Datei, Feld_Bezeichner);
		gefunden := s <> '';
		if gefunden then Lese_Int:= Str2Int(s)
		else Lese_Int := 0 ;
	end;
end; {tIni_IO.Lese_Int}

Procedure tIni_IO.Schreibe_Bool(Feld_Bezeichner: String; Bool: Boolean);
var boolstr: String[4];
Begin
	if Akt_Datei='' then fehlerbox(' Noch keine Akt_Datei zugewiesen!')
	else Begin
		boolstr:=Iif(bool,'Ja','Nein');
		Schreibe_Ini_Eintrag(Akt_Datei,Feld_Bezeichner, boolstr);
	end;
end;

Function tIni_IO.Lese_Bool( Feld_Bezeichner : String): Boolean;
var s: String;
Begin
	if Akt_Datei='' then fehlerbox(' Noch keine Akt_Datei zugewiesen!')
	else Begin
		s := Lese_Ini_Eintrag(Akt_Datei, Feld_Bezeichner);
		gefunden := s <> '';
		if gefunden then Lese_Bool:= s[1]='J';
	end;
end;

Procedure tIni_IO.Schreibe_Kommentar(Feld_Bezeichner,Kommentar: String);
Begin
  if Akt_Datei='' then fehlerbox(' Noch keine Akt_Datei zugewiesen!')
  else Begin
    Schreibe_ini_Kommentar(Akt_Datei,Feld_Bezeichner, Kommentar);
  end;
end;
{end of Implementation}

End.{of Unit}
