{Funktionen:
 0 Initialisierung
 1 Mauszeiger an
 2 Mauszeiger aus
 3 Mausposition und -Tasten
 4 Mausposition setzen
 7 Horizontalen Aktionsradius setzen
 8 Vertikaler   Aktionsradius setzen
10 Mauszeigererscheinung definieren
15 Maustempo definieren (Normal=10,Schnellste=0,Extrem Slow=100)
   Anmerkung zu Tastenanzahl : manche Maustreiber(Genius) untersttzen
                               nur 2 Tasten und melden diese dann auch,
                               obwohl 3 Hardwaretasten da sind!
}

Unit Maus_uni;

Interface
uses
    dos,crt;
type
    cursortype = array[0..31] of word;
const
     hourglass : cursortype =
     {1. Screenmask , 2. Cursormask}
     ($0001,$0001,$8003,$C7C7,$E38F,$F11F,$F83F,$FC7F,
      $F83F,$F11F,$E38F,$C7C7,$8003,$0001,$0001,$0000,

      $0000,$7FFC,$2008,$1010,$0820,$0440,$0280,$0100,
      $0280,$0440,$0820,$1010,$2008,$7FFC,$0000,$0000);

     Disque : cursortype =
      (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,32766,32766,32760,32760,32766,32382,31806,
       31806,32382,32766,32382,32382,32382,32766,0);

var
  regs         :registers;
  textmodus    : boolean;
  Tastenanzahl : word;
  Mausrasse    : string;

Procedure do_regs(a,b,c,d : word);
Procedure MausGrenzen(x1,x2,y1,y2 : word);
Procedure Mausan;
Procedure Mausaus;
Procedure MausSetzen(x,y:word);
Procedure Maustempo(t:word);
Procedure Gra_cursor(x,y  : integer;var Pattern : cursortype);

function lk:boolean ;

function rk:boolean;

function mittlerer : boolean;


function MPosX:word;

function MPosY:word;


function MausInit : boolean;
function MausTyp : string;
function MausTreiberVersion : word;
function MausIRQ : byte;

Implementation

Procedure do_regs(a,b,c,d : word);
begin
     with regs do
     begin
          ax := a;
          bx := b;
          cx := c;
          dx := d;
     end;
     intr($33,regs);
end;

function MausIRQ : byte;
begin
     do_regs(24,0,0,0);
     MausIRQ := regs.CL;
end;

function MausTreiberVersion : word;
begin
     do_regs(24,0,0,0);
     mausTreiberVersion := regs.bh+regs.bl;
end;

Function MausTyp : string;
begin
     do_regs(24,0,0,0);
     case regs.ch of
     1 : Maustyp := 'Bus-Maus';
     2 : Maustyp := 'Serielle Maus';
     3 : Maustyp := 'InPort-Maus';
     4 : Maustyp := 'PS/2-Maus';
     5 : Maustyp := 'HP-Maus';
     end;
end;

Function Mausinit : boolean;
begin
     do_regs(0,0,0,0);
     if regs.ax = $FFFF then
     begin
          mausinit := true;
          Tastenanzahl := regs.bx;
     end
     else mausinit := false;
end;

Procedure MausGrenzen(x1,x2,y1,y2 : word);
begin
     if x1=0 then x1:=1;
     if x2=0 then x2:=1;
     if y1=0 then y1:=1;
     if y2=0 then y2:=1;
     if textmodus then
     begin
          x1 := (x1-1)*8;
          x2 := (x2-1)*8;
          y1 := (y1-1)*8;
          y2 := (y2-1)*8;
     end;
     if not textmodus then
     begin
          x1 := (x1-1);
          x2 := (x2-1);
          y1 := (y1-1);
          y2 := (y2-1);
     end;
     do_regs(7,0,x1,x2);
     do_regs(8,0,y1,y2);
end;

Procedure Mausan;
begin
     do_regs(1,0,0,0);
end;

Procedure Mausaus;
begin
     do_regs(2,0,0,0);
end;

function lk:boolean ;
begin
     lk := false;
     do_regs(3,0,0,0);
     if (regs.bx and 1)= 1  then lk := true;
end;

function mittlerer : boolean;
begin
     mittlerer := false;
     do_regs(3,0,0,0);
     if (regs.bx and 4)=4  then mittlerer := true;
end;

function rk:boolean;
begin
      rk := false;
      do_regs(3,0,0,0);
      if (regs.bx and 2 )= 2 then rk := true;
end;

function MPosx:word;
begin
     do_regs(3,0,0,0);
     if textmodus then Mposx := regs.cx div 8 + 1;
     if not textmodus then Mposx := regs.cx + 1;
end;

function Mposy:word;
begin
     do_regs(3,0,0,0);
     if textmodus then Mposy := regs.dx div 8 + 1;
     if not textmodus then Mposy := regs.dx + 1;
end;

Procedure MausSetzen(x,y:word);
begin
     if x = 0 then x := 1;
     if y = 0 then y := 1;
     if textmodus then
     begin
          x := (x-1)*8;
          y := (y-1)*8;
     end;
     if not textmodus then
     x := x ;
     y := y ;
     do_regs(4,0,x,y);
end;

Procedure Maustempo(t:word);
begin
     if t = 0 then t := 1;
     do_regs(15,0,t,t*2);
end;

Procedure Gra_cursor(x,y  : integer;var Pattern : cursortype);
begin
     regs.ax := 9;
     regs.cx := y;
     regs.bx := x;
     regs.dx := ofs(pattern);
     regs.es := seg(pattern);
     Intr($33,regs);
end;

begin
  textmodus := false ;
  Mausrasse := '';
end.

